;**********************************************************************                                                            *
;    Filename:7TXCal.asm                 *
;    Date:  2016.05.04     2016.07.30                                                     *
;    File Version:                                          *
; ;7MHz CW TX Auto-CalibrationpvO / QKP6T.asm, mVFC1.asm(16F84A Freq.Count) 
;@@@@@mV676LCD1.asmiPIC16F676gJE^&S[^gݍ)@@@@@@@@@@@@@@@@@@  		                                                                  *
;    Author:   jk1xkp                                                     *
;    Company:                                                         *
;                                            
;	gp
;	ohb		PIC16F819 iȊOɂp\j
;
;		NbN	ONbN 10MHz
;**********************************************************************
;    Notes: 
;1.LCD 13ڂ Eƕ\Ƃ́APLL UnlockBVCObN͈͂H
;2.	EEPROM SAVE ADRESS
;		;#00h   #01h    #02h    #03h	#04h	#05h	#06h	#07h
;		;stROM, vxo,	nr0,	nr1,	Nband- 5Aaddress	
;3.LCD\ʒu
;LCD \̃AhX(DD RAM)(16i)
; |01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 (j	
;---------------------------------------------------------------------
;1|80 81 82 83 84 85 86 87 88 89 8a 8b 8c 8d 8e 8f 
;2|c0 c1 c2 c3 c4 c5 c6 c7 c8 c9 ca cb cc cd ce cf
;\ʒu(g)
;   5  6  ,  7  _  _  _  _ 
;   8  9  M  0  1  2  .  3   

;7.sATCFidENX^ERgXguq̔z͏ȗj
;		( H:[qopen  L:[q2.4kGRDɗƂ)
;	ohbPUeWPX	
;	()̓sԍ
;	RA7-OSC1(16)		10MHz Clock
;	RA6-OSC2(15)		Open	

;	RA5-MCL(04)		Calibration_SW 		
;	RA4(03)			FC input	
;	RA3(02)			Toggle
;	RA2(01)			LCD_RS
;	RA1(18)			LCD_E
;	RA0(17)			AD Converter Input
;		LCD RT08022
;	RB7(13)			LCD DB4		    
;	RB6(12)			LCD DB5	
;	RB5(11)			LCD DB6	(dqVR +)	
;	RB4(10)			LCD DB7 (	dqVR -)
;	RB3(09)				MCP4922_SCK	  
;	RB2(08)				MCP4922_LDAC 
;	RB1(07)			LED _Calib Lock ON	
;	RB0(06)			NC
;	GND	=R/~W,D
;				RB4`RB7́@L@xŃ^NgSWm
;    Notes:                
;  JX^}CY̎Ql
; Pj RX, TX͈ȉ̎g֌WŃvO쐬B
;7MHz CW RX́AIF=430kHz`442kHz /RX Local upper hetrodyne=7.430MHz
;7MHz CW TX Carrier=5.76MHz 	/TX Local upper hetrodyne=12.76MHz
; ā@TX Local- RX Local= 12.76MHz -(7MHz +IF)
;							=5.76MHz -IF
;                           =5.76MHz -o420kHz {[7.1kHz ` 21.9kHz]p
; 							=5,340kHz@-	[7.1kHz ` 21.9kHz]	
; 
; IF=420kHz +[8.9kHz ` 27.6kHz] =428.9kHz ` 447.6kHz
; RA0͓d@[1.4V   `@4.3V   ] ;
; 1023x 1.4V/5V*32=9.1 // 1023x 4.3V/5V*32=28.1
;**********************************************************************

	list      p=16f819           ; list directive to define processor
	#include <p16F819.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB2 & _DEBUG_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _WDT_OFF & _PWRTE_ON &_HS_OSC  

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file.
; See data sheet for additional information on configuration word settings.

#define		CalSW   PORTA,5		;calibration SW
#define		IN   	PORTA,4		;counter 
#define		TGL   	PORTA,3		;
#define		RS   	PORTA,2		;LCD_RS
#define		E  		PORTA,1		;LCD_E
#define		MK   	PORTA,1		; CW Buzzer

#define		M_CS   	PORTB,5		;MCP4922_CS		
#define		SDI  	PORTB,4		;MCP4922_Data 
#define		SCK   	PORTB,3		;MCP4922_SCK
#define		LDAC   	PORTB,2		;MCP4922_LDAC
#define		Cal_LK 	PORTB,1		;Calibration Lock <}130Hz

;***** VARIABLE DEFINITIONS
wait_cn		EQU	H'76'
wait_cn2	EQU	H'77'
cn			EQU	H'78'		
cs			EQU	H'79'		;sub-counter 
VALUE		EQU	H'7A'
scn			EQU	H'7B'	;Bank0-4 
ADDR		EQU	H'7C'
pc_temp		EQU	H'7D'
w_temp		EQU 0x7E        ; variable used for context saving 
status_temp EQU 0x7F        ; variable used for context saving
;   --------------- adress 20&H 
x0			EQU	H'20'	;X́AK #20h ԒnɒuĂ
x1			EQU	0x21
x2			EQU	0x22
x3			EQU	0x23
y0			EQU	0x24	
y1			EQU	0x25
y2			EQU	0x26
y3			EQU	0x27
if0			EQU	0x28	  	;IFg  IF_tab load
if1			EQU	0x29
if2			EQU	0x2A
if3			EQU	0x2B
vfo0		EQU	0x2C		;Lo(VFO)B
vfo1		EQU	0x2D
vfo2		EQU	0x2E		
vfo3		EQU	0x2F			
;   -------------- adress 30&H
dec0		EQU	0x30		; 10ii[ꏊiPOoCgj dec0́AK #30h ԒnɒuĂ
dec1		EQU	0x31
dec2		EQU	0x32		;10MHz
dec3		EQU	0x33		;1MHz
dec4		EQU	0x34		;100kHz
dec5		EQU	0x35				
dec6		EQU	0x36		;1kHz
dec7		EQU	0x37		;100Hz
dec8		EQU	0x38
dec9		EQU	0x39		;1Hz
try_num		EQU	0x3A	;calibration Try񐔁@8;try_num=B'11111111'ٰOut
cal_in		EQU	0x3B	;if Calibration<255Hz, then cal_in.0=1, else cal_in.0=0	 	
FrCw		EQU	0x3C	;if FrCw=1, then CWanounce, else FrCw=0 and DSP Freq.Counter
poi			EQU	0x3D		
mode		EQU	0x3E		;
History		EQU	0x3F	;CW anounce 2 times after Power ON
;    ------------- adress 40&H
val0		EQU	0x40		; ϊliRQrbgj
val1		EQU	0x41
val2		EQU	0x42
val3		EQU	0x43
val_m		EQU	0x44		; ꎞ]i[ꏊiTu[`Ŏgpj
ct			EQU	0x45		;Sub counter
d4			EQU	0x46
d8			EQU	0x47
Vs			EQU	0x48	;S meter Volt 	
overf		EQU	0x49
lasttm		EQU	0x4A		;value of the last TMR0
N			EQU	0x4B		;preccaler N=1,or 8  1<N<255
Ngate		EQU	0x4C		;Gate time multiple Ngate=5 or 1
length		EQU	0x4D
ccode		EQU	0x4E		
speed		EQU	0x4F		;spead=D'120' Xs[h́A{œKXύXB
;    ------------- adress 50&H
dp1			EQU	0x50		;LCD Psځ@S meter\/dp1́AK #50h ԒnɒuĂ/
dp2			EQU	0x51		;
dp3			EQU	0x52		;
dp4			EQU	0x53
dp5			EQU	0x54				
dp6			EQU	0x55		;
dp7			EQU	0x56		;
dp8			EQU	0x57
mcp0		EQU	0x58		;MCP4922 DAC data
mcp1		EQU	0x59
VR0			EQU	0x5A	;AF VR 
VR1			EQU	0x5B	
cal_pm		EQU	0x5C	;Calibration Plus /Minus//uif (TX_VXO- RX_VXO) +IF <5.76 ,then cal_pm.0=1 Else cal_pm.0=0
VCF			EQU	0x5D	;AF Volume Change Flag// if AF VR Change,VCF.0=1, else 0
AdjF		EQU	0x5E	;dRb.4_SW=ON ɂā@AdjF=1, NE602 MIXo͕\̒[h 
temp1		EQU	0x5F
;    ------------- adress 60&H
HisROM		EQU	0x60	;K #60h ԒnɒuĂ/
AFVol		EQU	0x61	;#61h Ԓn; 0 <AFVol< 20 //VR(0-1)= (255- AFVol x 2) x 16: 
VXO_V0		EQU	0x62	;#62h Ԓn;TX VXO 12.76MHz Control Volt;K 
VXO_V1		EQU	0x63	;K #63h ԒnɒuĂ/

;**********************************************************************
	ORG     0x000             ; processor reset vector
	goto    start              ; go to beginning of program

	ORG     0x004             ; interrupt vector location

;-----------
; remaining code goes here
;--------------------------------------------------------------
;S_tabl 	addwf	PCL,1 Old data
	;	retlw	D'188'	;dp1	;poi=0	0.920V S0--
	;	retlw	D'178'	;dp2	;poi=1	0.870V S3
	;	retlw	D'127'	;dp3	;poi=2	0.624V S6
	;	retlw	D'51'	;dp4	;poi=3	0.249V S9
	;	retlw	D'25'	;dp5	;poi=4	0.124V  9+20dB
	;	retlw	D'14'	;dp6	;poi=5	0.069V  9+40dB
	;	retlw	D'4'	;dp7	;poi=6	0.017V  9+60dB
	;	retlw	D'2'	;dp8	;poi=7	0.010V  9+60dB
	;	retlw	D'0'		;poi=8	0.0V 

S_tabl 	addwf	PCL,1 
		retlw	D'201'	;dp1	;poi=0	0.980V S0--
		retlw	D'199'	;dp2	;poi=1	0.972V S3
		retlw	D'197'	;dp3	;poi=2	0.965V S5
		retlw	D'164'	;dp4	;poi=3	0.800V S7
		retlw	D'102'	;dp5	;poi=4	0.500V  S9
		retlw	D'61'	;dp6	;poi=5	0.300V  9+10dB
		retlw	D'10'	;dp7	;poi=6	0.050V  9+20dB
		retlw	D'1'	;dp8	;poi=7	0.001V  9+30dB
		retlw	D'0'		;poi=8	0.0V 
	
tab_dp	addwf	PCL,1  	;f[^7bit=1ƂBAhXf[^͂̂܂
		retlw	H'50'	;poi=0  dp1	;S Meter
		retlw	H'51'	;poi=1  dp2	;S Meter	
		retlw	H'52'	;poi=2	
		retlw	H'53'	;poi=3		 
		retlw	H'54'	;poi=4	
		retlw	H'55'	;poi=5	
		retlw	H'56'	;poi=6		
		retlw	H'57'	;poi=7
 
;   	ȉ2s
		retlw	H'32'	;poi=8	dec2; 10MHz
		retlw	H'33'	;poi=9 dec3; 1MHz
		retlw	H'cd'	;poi=10	uMv	 ;4dh+80h
		retlw	H'34'	;poi=11	dec4; 100kHz
		retlw	H'35'	;poi=12	dec5; 10kHz
		retlw	H'36'	;poi=13	dec6; 1kHz
		retlw	H'ae'	;poi=14	u.v;2eh+80h
		retlw	H'37'	;poi=15	dec7; 0.1kHz	 
		nop	


IF_set		; Base IF Frequency=429kHz//IF0=429,000Hz=H'06 8b c8'
IF_1	movlw	H'c8'		;if0	
		movwf	y0
		movlw	H'8b'		;if1
		movwf	y1
		movlw	H'06'		;if2	
		movwf	y2
		movlw	H'00'		;if3	
		movwf	y3

		call	adlp_IF	;x= 4.5`14.1kHz ABIF set;A/DϊJn@@AN0|[g@AiO

		call	add_xy	;(32bit)(32bit){y(32bit)@
		movf	x3,0		;
		movwf	if3

		movf	x2,0
		movwf	if2

		movf	x1,0
		movwf	if1

		movf	x0,0
		movwf	if0
		return	


Dif_tab	; 12.76MHz -(7MHz +IF)=5.76MHz - IF
		addwf	PCL,1  		;cycle3
		retlw	H'00'		;F0	//5,760,000Hz=H'57 e4 00'
		retlw	H'e4'		;F1		
		retlw	H'57'		;F2	        
		retlw	H'00'		;F3
		sleep

;  烂[Xւ̕ΐAu[XK@\tGL[̐A
;                          p121 CQ Mar.1998 JR7RAR  QƂB
;  Wbit code  1 0 1 0 0  1 0 0   ŏ̂T\  °°
;              			Ō̂R\ S
;                             ẮAubv\B
;   	1 0 1 1 0  1 1 1   V̏ꍇ́A6ڂ_ ° \u(v
;       0 0 1 1 0  1 1 0   6̏ꍇ́A6ڂZ_  \ uHv
CW_tab	addwf	PCL,1  		;cycle3==== ʏ탂[hAA BBBAA@BBI
		retlw	B'11111101'		;poi="0"
		retlw	B'01111101'		;poi="1"
		retlw	B'00111101'		;poi="2" 
		retlw	B'00011101'		;poi="3" 
		retlw	B'00001101'		;poi="4"
		retlw	B'00000101'		;poi="5"
		retlw	B'10000101'		;poi="6" 
		retlw	B'11000101'		;poi="7"	
		retlw	B'11100101'		;poi="8" 
		retlw	B'11110101'		;poi="9"
		retlw	B'01000011'		;poi="10"/ R;"."
		retlw	B'10000001'		;"e" g qh~
		retlw	B'10000001'		;"e" g qh~
		retlw	B'10000001'		;"e" g qh~
		retlw	B'10000001'		;"e" g qh~
		retlw	B'10000001'		;"e" g qh~
		retlw	B'10000001'		;"e" g qh~
		sleep
;CW_tab	addwf	PCL,1  		;cycle3=== ȗ[hBB
;		retlw	B'11111101'		;poi="0"
;		retlw	B'01000010'		;poi="1" gc[
;		retlw	B'00100011'		;poi="2" ggc[
;		retlw	B'00010100'		;poi="3" gggc[
;		retlw	B'00001101'		;poi="4"
;		retlw	B'00000101'		;poi="5"
;		retlw	B'10000101'		;poi="6" 
;		retlw	B'11000101'		;poi="7"	
;		retlw	B'11100101'		;poi="8" 
;		retlw	B'10000010'		;poi="9" c[g
;		retlw	B'01000011'		;poi="10"/ R;"."
;		retlw	B'10000001'		;"e" g qh~
;		retlw	B'10000001'		;"e" g qh~
;		retlw	B'10000001'		;"e" g qh~
;		retlw	B'10000001'		;"e" g qh~
;		retlw	B'10000001'		;"e" g qh~
;		retlw	B'10000001'		;"e" g qh~
;		sleep
;----------------------------------------------------------------------------

start	bsf		STATUS,5	;oN1
		movlw	B'11111111'	;rb.0-rb.7sin  !rb,#11111111b	
		movwf	TRISB		;trisb
		movlw	B'11100111'		;prescaler 1/256 set ;RBvAbvȂB; オJEg	
		movwf	OPTION_REG
		bcf  	STATUS,RP0	;oN0
		clrf	PORTB

		movlw	D'1'
		btfss	PORTB,0		;if Rb.0=H during Power On, FrCW=D'1' else =D'0'
		movlw 	D'0'
		movwf	FrCw


		movlw	D'0'	;@AFVol=0 ;Silent
		movwf	AFVol	;0 <AFVol<= 20 //VR(0-1)= (255- AFVol x 4) x 16
		call	AF_conv ; AFVol @VR0, VR1 convert

		call	writb
		movf	VR0,0		;AF VR Control Volt
		movwf	mcp0
		movf	VR1,0
		movwf	mcp1
		call	DAC_B

		movlw	D'15'
		movwf	wait_cn
		call	wait_ms

		bsf		STATUS,5	;oN1
		clrwdt			;prescalerNA
		movlw	B'01100111'		;prescaler 1/256 set ;RBvAbv; オJEg		
		movwf	OPTION_REG	

		movlw	B'11111101'	;rb.0-rb.7sin  !rb,#11111111b	
		movwf	TRISB		;trisb

		movlw	B'11110001'	;ra1,2,3, inputoutput
		movwf	TRISA
		bcf  	STATUS,RP0	;oN0
		clrf	PORTA
		clrf	PORTB

		clrf	AdjF	;;dRb.4_SW=ON ɂā@AdjF=1, NE602 MIXo͕\̒[h 
		btfss	PORTB,4 
		bsf		AdjF,0	;

		bsf  	STATUS,RP0	;oN1
		movlw	B'00001101'	;rb.0-rb.7sin  !rb,#11111111b	
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0
		clrf	PORTB

		call	writb
		call	init_lcd		; kbc

		call	readb	;rb.2-7s input mode	;
		;------------------xxx
start2	clrf	cal_pm
		clrf	dec0
		clrf	dec1	
		clrf	dec2
		clrf	dec3
		clrf	dec4	
		clrf	dec5
		clrf	dec6
		clrf	dec7
		clrf	dec8
		clrf	dec9		
		clrf	TMR0		;TMR0NA

		clrf	try_num
		clrf	cal_in

		movlw	H'5F'	; Lettter u_v
		movwf	dp1
		movwf	dp2	
		movwf	dp3
		movwf	dp4
		movwf	dp5
		movwf	dp6
		movwf	dp7
		movwf	dp8

s22		call	load_m
		movlw	H'F0'
		subwf	HisROM,0
		btfsc	STATUS,Z	;if HisROM=H'F0', then goto	s26
		goto	s26

s25		movlw	H'F0'
		movwf	HisROM  ;if EEPRPM EEADR 0=H'F0', EEPRPM OK

		movlw	H'00'
		movwf	VXO_V0		;TX VXO 12.76MHz Control Volt= 2.5V =H'08 00'
		movlw	H'08'		
		movwf	VXO_V1

		movlw	D'3'
		movwf	AFVol	;0 <AFVol<= 20 //VR(0-1)= (255- AFVol x 4) x 16
		call	Memo

s26		movf	VXO_V0,0		;TX VXO 12.76MHz Control Volt
		movwf	mcp0
		movf	VXO_V1,0
		movwf	mcp1
		call	DAC_A

		call	AF_conv ; AFVol @VR0, VR1 convert
		movf	VR0,0		;AF VR Control Volt
		movwf	mcp0
		movf	VR1,0
		movwf	mcp1
		call	DAC_B
		
		movlw	D'5'	;Gate time multiple Ngate=5(0.2sec) or =1(1.0sec)
		movwf	Ngate

		movlw	D'2'
		movwf	History	;;CW anounce 2 times after Power ON		

		movlw	D'255'		
		movwf	wait_cn
		call	wait_ms
		
main		
;++=========== ȉ USERɂā@KXύX@	=========================
		
		movlw	D'120'	;10 WPM at speed=120
		movwf	speed 
;++================ ύXӏ@܂ ===========================
		call	Ngate_set	;Gate Time multipled by 5 or 1
		call	N_set		;Prescaler set /N=1 or N=8
		call	IF_set		;IF frequency set IF=420kHz +[ADC*128]
		clrf	try_num	;calibration Nums of Trials
		clrf	VCF	;AF Volume Change Flag// if AF VR Change,VCF.0=1, else 0

		call	c_main		; Count /resulting vfo ///0.2sec
		call	VFOcalc		;resulting actual VFO
		call	DSP_cal		;resulting dec0-dec9

		movlw	D'1'
		subwf	FrCw,0
		btfss	STATUS,Z	;if FrCw=1, then goto CWm
		goto	main1	;8LCDI@
		goto	CWm		;CW anouncementI

	;++ temp Displaying test +---
;	testmn	

	;	movlw	H'08'
	;	movwf	dec0

	;	movlw	H'07'
	;	movwf	dec1
	
	;	movlw	H'06'
	;	movwf	dec2
	
	;	movlw	H'05'
	;	movwf	dec3

	;	movlw	H'04'
	;	movwf	dec4
	
	;	movlw	H'03'
	;	movwf	dec5
	
	;	movlw	H'02'
	;	movwf	dec6

	;	movlw	H'01'
	;	movwf	dec7
	
	;	movlw	H'00'
	;	movwf	dec8
	
	;	movlw	H'07'
	;	movwf	dec9


	;++ temp test+---	

main1	;LCD 2sڂ֕\
		call	put2nd	;g\@LCD 2sڂ֕\
		;*******************
		btfss	AdjF,0	;;dRb.4_SW=ON ɂā@AdjF=1, NE602 MIXo͕\̒[h 
		goto	main12

		call 	DevC_mn		;;VFO= (TX_VXO -RX_VXO) [h//0.2sec
		call	VFOcalc		;resulting actual VFO
		call	Mix_cal
		call	put1st		;Mix outg 1sڂ֕\
		goto	main40
		;********************
main12	call	adloop		;S meter
		call 	LCD_sm
		call	put1st		;S Meter LCD 1sڂ֕\

			;<<<<<<<<<<<<<<<<<<<<<
main40	;;Calib SW<PORTA.5> ONɂTX VXO@`@RX VXO@5.76MHɂCalibration 
		movlw	B'11111111'
		subwf	try_num,0	;calibration Nums of Trials
		btfsc	STATUS,Z
		goto	main50
		
		call 	DevC_mn		;;VFO= (TX_VXO -RX_VXO) [h//0.2sec
		call	VFOcalc		;resulting actual VFO

		call	add_vfo;  vfo(32bit)vfo(32bit){if(32bit)@;x= o(TX_Lo- RX_Lo) +IF@p
		call	Devchk	;VFO= VFO +IF	
						;+/-check for cal_pm,0		;if (TX_VXO- RX_VXO) +IF <5.76 ,then cal_pm.0=1
		btfss	cal_pm,0	;;if (TX_VXO- RX_VXO) +IF <5.76 ,then cal_pm.0=1 Else cal_pm.0=0
		call	DevCalm ; x= o(TX_VXO- RX_VXO) +IF@p-5.76MH
		btfsc	cal_pm,0
		call	DevCalp	; x= 5.76MHz -o(TX_VXO- RX_VXO) +IF@p

		btfsc	cal_in,0	;if Calibration<128Hz, then cal_in.0=1, else cal_in.0=0	
		bsf		PORTB,1		;calibration  Lock LED
		btfss	cal_in,0	;if Calibration<128Hz, then cal_in.0=1, else cal_in.0=0	
		bcf		PORTB,1		;calibration  Lock LED OFF

		btfss	cal_in,0	;if Calibration<128Hz, then cal_in.0=1, else cal_in.0=0	
		goto	main45
		btfss	CalSW		;PORTA,5 	 ;if PORTA,5=L, then EEPROM Save 
		call	Memo
		goto	main50

main45	btfsc	CalSW   ;PORTA,5		;calibration SW		
		goto	main50	
		movf	VXO_V0,0		;TX VXO 12.76MHz Control Volt
		movwf	mcp0
		movf	VXO_V1,0
		movwf	mcp1
		call	DAC_A

		bsf		STATUS,C
		rlf		try_num,1	;calibration Nums of Trials
		goto	main40
			;<<<<<<<<<<<<<<<<<<<<	
main50	nop		;; AF Volume 
		btfss	CalSW
		goto	main50
				
main52	btfsc	AdjF,0	;;dRb.4_SW=ON ɂā@AdjF=1, NE602 MIXo͕\̒[h 
		goto	main54
		call	adloop		;[v2ڂS meter
		call 	LCD_sm
		call	put1st		;S Meter LCD 1sڂ֕\
	
			;; AF Volume 
main54	clrf	try_num
		call	readb
		btfss	PORTB,4	
		call	AF_dec ; AFVol dec
		btfss	PORTB,5		
		call	AF_inc ; AFVol inc
		btfss	VCF,0	;if AF VR Change,VCF.0=1, else 0
		goto	main60
main55	call	put1st
main58	movf	VR0,0		;AF VR Control Volt
		movwf	mcp0
		movf	VR1,0
		movwf	mcp1
		call	DAC_B
		call	wait_255	;LCD Vol\;0.5b~Ԋu
		call	wait_255		
main60	goto 	main
	;====================
	;-------------------
CWm	;;;CW anounce
		movf	History,1
		btfsc	STATUS,Z	;if History=0, then Cwm2 
		goto	Cwm2
		decf	History,1
		goto	Cwm31

Cwm2	;bsf		STATUS,5		;oN1
		;movlw	B'00010110'		;ra.0=OUT -ra.1 IN 
		;movwf	TRISA			;trisa
		;bcf		STATUS,5	;oN0
		nop
		call	readb
		btfsc	PORTB,0	;if Rb0=L,then CW_anounce_ON, else goto main
		goto	main
Cwm31	movlw	D'3'		;dec4(100kHz),dec5,dec6-"."-dec7(0.1kHz) 4Digits CWo
		movwf	cn

		movlw	dec4
		movwf	FSR			;INDF	dec4
CWm32	movf	INDF,0		
		call	CW_tab
		movwf	ccode

		call	CWtrans
		incf	FSR,1
		decfsz	cn,1
		goto	CWm32

		movlw	D'10'		;;CW code="."
		call	CW_tab
		movwf	ccode
		call	CWtrans

		movlw	dec7		
		movwf	FSR			;INDF	dec7
		movf	INDF,0	
		call	CW_tab
		movwf	ccode
		call	CWtrans

		call	wait_255	;1b~Ԋu
		call	wait_255
		call	wait_255
		call	wait_255	

		goto	main
	;CWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW--------------------
CWtrans	
		movf	ccode,0
		andlw	B'00000111'
		movwf	length

		movf	ccode,0
		andlw	B'11111000'
		movwf	ccode

		movlw	D'0'
		subwf	length,0
		btfss	STATUS,Z
		goto	Ctrans0
		call	spce14		
		return
	;---------
Ctrans0	rlf		ccode,1
		btfsc	STATUS,C
		bsf		MK
		btfss	STATUS,C
		bcf		MK

		btfsc	STATUS,C
		call	mrk6
		btfss	STATUS,C
		call	mrk2
		call    spce2
		decfsz	length,1
		goto	Ctrans0
		call	spce6
		return
	;----------
spce14	call	spce1		;2003.6.23 C
		call	spce1
		call	spce1
		call	spce1
		call	spce1
		call	spce1
		call	spce1
spce8	call	spce1
		call	spce1
spce6	call	spce1
		call	spce1
spce4	call	spce1
		call	spce1
spce2	call	spce1
spce1	bcf		MK
		call	wait_mk	
		return
	;--------------------
mrk6	call	mrk1
		call	mrk1
mrk4	call	mrk1
		call	mrk1
mrk2	call	mrk1
mrk1	bsf		MK
		call	wait_beep		;output 1.2kHz pulse
	;	call	wait_mk			;output continuouse 
		return

	;-----------------------------
wait_beep
	;	goto	wait_mk	;1)continuouse  1) or 2)ꂩI
		goto	pwait_mk	;2);1200Hz Pulse

pwait_mk	;1.2kHz Pulse		 ;250 * (1+3)=1000sec
		bcf		STATUS,C
		rrf		speed,0
		movwf	wait_cn			; Default speed=#150/2=75
		nop	
pwtm1	bsf		MK
		movlw	D'250'	;1000cycle	 
		movwf	wait_cn2					
pwtm2	nop					;1cycle		
		decfsz	wait_cn2,1	;1cycle		
		goto	pwtm2		;2cycle

pwt1	bcf		MK
		movlw	D'250'	;1000cycle		 
		movwf	wait_cn2					
pwt2	nop					;1cycle		
		decfsz	wait_cn2,1	;1cycle		
		goto	pwt2		;2cycle

		decfsz	wait_cn,1		
		goto	pwtm1
		return			;	

wait_mk	;continuouse		 ;250 * (1+3)=1000sec
		movf	speed,0		; Default speed=#150
		movwf	wait_cn	
		nop	
wtm1	movlw	D'250'	;	 
		movwf	wait_cn2					
wtm2	nop					;1cycle	
		decfsz	wait_cn2,1	;1cycle			
		goto	wtm2		;2cycle
		decfsz	wait_cn,1		
		goto	wtm1
		return			;
	;CWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW-------------------- 
	;-----------------------
Ngate_set
		movlw	D'5' 	; gate time =0.2sec then Ngate=5@multipled
		movwf	Ngate
		return

N_set
		movlw	D'1'
		movwf	N
		return

	;;;;+++++++++++
;	IF set;A/DϊJn@@AN0|[g@AiO
adlp_IF	bsf		RS	
		movlw	B'01000001'	;set AD_channel=AN0, conversion_clock=16Tosc, )  
		movwf	ADCON0

		bsf		STATUS,5	;oN1
		movlw	B'01001110'	;pinset(AN4=D,AN3=D,AN2=D,AN1=D,AN0=Analog, Vref+=5V, Vref-=GND) 
		movwf	ADCON1	;Left Justified 
		bcf		STATUS,5	;oN0

		movlw	D'25'		;acquisition time wait 25usec
		movwf 	wait_cn	
		call	wait_us 

		bsf  	ADCON0,GO
ad_pol_IF		
		nop  
		btfsc	ADCON0,GO
		goto	ad_pol_IF		;AD conv polling
		movf	ADRESH,0
		movwf	x1			;ADϊLeft Justified@x1Ɏ荞݁@(0-1023)*64
		movf	ADRESL,0	;
		movwf	x0		

		bcf  	ADCON0,0	;AD OFF
		bcf  	ADCON0,GO	;AD conv reset
	;;;;+++++++++++
		clrf	x2
		clrf	x3
		bcf		STATUS,C
		rrf		x1,1  		;x= x *64/2 =(0-1023)*32=(0-32,736)
		rrf		x0,1

		bcf		STATUS,C
		rrf		x1,1  		;x= x *64/4 =(0-1023)*16=(0-16,368)
		rrf		x0,1
		return

	;--------------------
DevC_mn	bcf		RS	;VFO= (TX_VXO -RX_VXO) [h
		bsf		STATUS,5		;oN1
		bcf		TRISA,3			;trisa;ra.3=TGL out
		bcf		STATUS,5	;oN0
		bsf		TGL			;ra.3=H
		clrf	vfo0
		clrf	vfo1
		clrf	vfo2
		clrf	vfo3
		call	wt15ms ;wait 15m sec
		movlw	D'5'
		subwf	Ngate,0
   		btfsc	STATUS,Z
		goto	c_m0.2g

		movlw	D'1'
		subwf	Ngate,0
   		btfsc	STATUS,Z
		goto	c_1m	
	;--------------------
c_main	bsf		RS	;VFO= RX_VXO [h
		bsf		STATUS,5		;oN1
		bcf		TRISA,3			;trisa;ra.3=TGL out
		bcf		STATUS,5	;oN0
		bsf		TGL			;ra.3=H
		clrf	vfo0
		clrf	vfo1
		clrf	vfo2
		clrf	vfo3
		call	wt15ms ;wait 15m sec
		movlw	D'5'
		subwf	Ngate,0
   		btfsc	STATUS,Z
		goto	c_m0.2g

		movlw	D'1'
		subwf	Ngate,0
   		btfsc	STATUS,Z
		goto	c_1m
;========================================
c_1m	movlw	D'250'	;gate time=1.0sec
		movwf	cn	

		bsf		STATUS,5	;oN1
		bsf		TRISA,3		;;ra.3 input mode=high impedance/TMR0̊Jn
		bcf		STATUS,5	;oN0
		clrf		lasttm
		clrwdt
		clrf		TMR0		;JE^TMR0NA,PSANA

;		sleep		;temp  1000 msec JEg̎n_
		;	;			;delay 2cycle			|	
c_1m1	call 	disp2cy		;(2+3994)*250=999,000	| 	
							;						|  		
		decfsz	cn,1		;249+2cycle				| 			
		goto 	c_1m1		;249*2					|999,749cycle				
		;------------------------------------------------------------
		movlw	D'80'		;1+(3*79+2+2)=242    	|@
		movwf 	wait_cn		;1                  	| 
		call	wait_us 	;2cycle					|   245cycl
		;------------------------------------------------------------
		movlw	D'250'		;1cycle					|
		movwf	cn			;1cycle					|
c_1m2	call 	disp2cy		;(2+3994)*250=999,000	| 	
							;						|  		
		decfsz	cn,1		;249+2cycle				| 			
		goto 	c_1m2		;249*2					|999,751cycle
		;------------------------------------------------------------
		movlw	D'80'		;1+(3*79+2+2)=242    	|@
		movwf 	wait_cn		;1                  	| 
		call	wait_us 	;2cycle					|   245cycl
		;------------------------------------------------------------
		movlw	D'125'		;1cycle					|
		movwf	cn			;1cycle					|
c_1m3	call 	disp2cy		;(2+3994)*125= 499,500	| 	
							;						|  		
		decfsz	cn,1		;124+2cycle				| 			
		goto 	c_1m3		;124*2					|499,876cycle
		;------------------------------------------------------------
		movlw	D'41'		;1+(3*40+2+2)=125    	|@
		movwf 	wait_cn		;1                  	| 
		call	wait_us 	;2cycle					|   128cycle  

					;		 					(v2,499,994 step) 

c_1m4	nop
	;	nop			;Ԓ							| 1 (1)
		nop			;Ԓ							| 1 (1)
		nop			;Ԓ							| 1 (1)
		bsf		STATUS,5	;oN1					| 1
		bcf		TRISA,3	;trisa	ra.3 OUT;TMR0̒~ | 1 (2)
;	;	sleep		;temp  1000 msecJEg̏I_  (v2,500,000 step)
		bcf		STATUS,5	;oN0
		bcf		TGL
		goto	cmain2
;============================================
c_m0.2g	movlw	D'125'		;gate time=0.2sec
		movwf	cn	

		bsf		STATUS,5	;oN1
		bsf		TRISA,3		;;ra.3 input mode=high impedance/TMR0̊Jn
		bcf		STATUS,5	;oN0
		clrf		lasttm
		clrwdt
		clrf		TMR0		;JE^TMR0NA,PSANA

;		sleep		;temp  200 msec JEg̎n_
c_m0.2g2		;	;			;delay 2cycle			|	
		call 	display		;(2+3993)*125=499,375	| 	
							;						|  		
		decfsz	cn,1		;124+2cycle				| 			
		goto 	c_m0.2g2		;124*2					|499,749cycle				
		;------------------------------------------------------------
		movlw	D'80'		;1+(3*79+2+2)=242    	|@
		movwf 	wait_cn		;1                  	| 
		call	wait_us 	;2cycle					|   245cycle

c_m0.2g3					;		 					(v499,994 step)  
	;	nop			;Ԓ							| 1
	;	nop			;Ԓ							| 1
		nop			;Ԓ							| 1
		nop			;Ԓ							| 1 (4)
		bsf		STATUS,5	;oN1					| 1
		bcf		TRISA,3	;trisa	ra.3 OUT;TMR0̒~ | 1 (2)
;	;	sleep		;temp  200msecJEg̏I_  (v500,000 step)
		bcf		STATUS,5	;oN0
		bcf		TGL
;============================================
cmain2	clrf	ct		;ct=1 in caes of TRM0=FF, else ct=0
		movlw	H'FF'		;Compensation when TMR0=FF,  
		subwf	TMR0,0
		btfss	STATUS,Z
		goto 	cmain5
cm21	;temp
		incf	ct,1	;;ct=1 in caes of TRM0=FF, 	
		movlw	D'140'	;TGL 140 times
		movwf	cn

cm22	bcf		TGL		;port Ra4̃gO
		nop
		bsf		TGL		;port Ra4̃gOオ@PSA@increment
		decfsz	cn,1
		goto	cm22

		movlw	D'140'	;TGL 140 times@again
		movwf	cn
cm23	bcf		TGL		;port Ra4̃gO
		nop
		bsf		TGL		;port Ra4̃gOオ@PSA@increment
		decfsz	cn,1
		goto	cm23

cmain5	call		dl5		;overflow check after last check
		nop
		movf 	TMR0,0		;TMR0datavfo[1]
		movwf	vfo1

		incf	vfo0,1
toggle	decf	vfo0,1
		bcf		TGL		;port Ra4̃gO
		nop
		bsf		TGL		;port Ra4̃gOオ@PSA@increment
		nop
		nop
		nop
		nop
		movf	TMR0,0
		subwf	vfo1,0	;vfo[1]-TMR0=0ł Z=1
		btfsc	STATUS,Z
		goto	toggle
		decf	vfo0,1	;vfo[0]ւ prescalerl̎荞݊B
		nop	

sub280	movf	ct,1	;if ct=0, then TMR0 not= FF and return 
		btfsc	STATUS,Z	
		return
		movlw	D'140'		;vfo= vfo- 140- 140
		subwf	vfo0,1
		movlw	D'1'		
		btfss	STATUS,C
		subwf	vfo1,1		
		btfss	STATUS,C		
		subwf	vfo2,1		
		btfss	STATUS,C
		subwf	vfo3,1	

		movlw	D'140'
		subwf	vfo0,1
		movlw	D'1'		
		btfss	STATUS,C
		subwf	vfo1,1		
		btfss	STATUS,C		
		subwf	vfo2,1		
		btfss	STATUS,C	
		subwf	vfo3,1		
		return

;------------------------------------
;------------------------------------
disp2cy	nop		;;3994steps =3993 +1 (return=2)
display			;;3993steps =665*6 +1 +2 (return=2)
		call	delay220			;2+663
		call	delay220			;2+663
		call	delay220			;2+663@Chek@TOIF@@@
		call	delay220			;2+663
		call	delay220			;2+663
		call	delay220			;2+663@Check TOIF
		nop							;1  Ԃ傤	
		return						;2     (=2)  
;--------------------------------------------
delay245	nop			;G645steps=261.0 usec̃[`------------
		nop
delay244	;------------------------G643steps=260.0 usec̃[`-----------664-
		nop					;1  Ԓ		|
		nop					;1  Ԓ		|
		nop					;1  Ԓ		|
		nop					;1  Ԓ		|

;	-----------------------------------------------------------------
delay220	;573+90=663step				
ch_tof1						;TMR0̃I[ot[(TOIF)̃`FbN[`---
		movlw	D'189'		;1+(3*188cycle +2+2)+4=573----------------------------
		movwf 	wait_cn		;1				 | 
		call	wait_us 	;2cycle		 	 |;(3-1)*3+ 1*2+ return2
		nop					;1  Ԓ		 |
delay90
ch_tof0	movlw	D'21'		;1+(20*3cycle+2+2)+25=90---------------------
		nop					;1cycle	 |	 	 |
		movwf 	wait_cn		;1cycle	 |	 	 |;(22-1)*3+ 1*2+ return2
		call	wait_us 	;2cycle   |      	 |
dl5		movf	INTCON,0	;1cycle	 |	 	 |
		movwf	overf		;1cycle	 |	 	 |
		movwf	lasttm		;1		 |tmr0lasttm when intcon,C overflow 	 |
		nop					;1		;|
		nop					;1		;
	;	;-----------------------	
		nop					;1cycle	 |	 	 |
		nop					;1cycle	 |	 	 |
		nop					;1cycle	 |	 	 |
		nop					;1cycle	 |	 	 |
		bcf		STATUS,C	;1cycle   |		 |
		movlw	D'1'		;1cycle	 |  25cy	 |
		btfsc	overf,2		;2cycle	 | 		 |
		addwf	vfo2,1		;0		 |		 |
		btfsc	STATUS,C	;2cycle	 |		 |
		addwf	vfo3,1		;0		 |		 |
		btfsc	overf,2		;2cycle	 |	 	 |
		bcf		INTCON,2	;0cycle 	 |      	 |
		nop					;1cycle	 |	 	 |
		nop					;1cycle	 |	 	 |
		return				;2cycle---------------
;;----------------------------------------------------------------- 
;------------------------------------
Devchk	;; Check o(TX_Lo- RX_Lo) +IF@p <>= 5.76MHz ???
		movlw	D'3'
		call	Dif_tab	; =5.76MHz
		subwf	vfo3,0  	;W= vfo3<VXO_12.76MHz -Lo_7MHz> + (256-5.76MHz)
		btfss	STATUS,C	; if vfo3 < 5.76MHz, then Dev1
		goto 	Dev1
		btfss	STATUS,Z	; if vfo3 not= 5.76MHz, then Dev2
		goto 	Dev2

		movlw	D'2'
		call	Dif_tab	; =5.76MHz 
		subwf	vfo2,0  	;W= vfo2<VXO_12.76MHz -Lo_7MHz> + (256-5.76MHz)
		btfss	STATUS,C	; if vfo2 < 5.76MHz, then Dev1
		goto 	Dev1
		btfss	STATUS,Z	; if vfo2 not= 5.76MHz, then Dev2
		goto 	Dev2

		movlw	D'1'
		call	Dif_tab	; =5.76MHz 
		subwf	vfo1,0  	;W= vfo1<VXO_12.76MHz -Lo_7MHz> + (256-5.76MHz)
		btfss	STATUS,C	; if vfo1 < 5.76MHz, then Dev1
		goto 	Dev1
		btfss	STATUS,Z	; if vfo1 not= 5.76MHz, then Dev2
		goto 	Dev2

		movlw	D'0'
		call	Dif_tab	; 12.76MHz -(7MHz +IF)=5.76MHz 
		subwf	vfo0,0  	;W= vfo0 + (256-5.76MHz)
		btfss	STATUS,C	; if vfo0 < 5.76MHz, then Dev1
		goto 	Dev1
		goto	Dev2 

Dev1	bsf		cal_pm,0		;if (TX_Lo- RX_Lo) +IF <5.76 ,then cal_pm.0=1 
		return	

Dev2	bcf		cal_pm,0		;if (TX_Lo- RX_Lo) +IF =>5.76 ,then cal_pm.0=0 
		return
;;----------------------------------------------------------------- 
DevCalm ; x= o(TX_Lo- RX_Lo) +IF@p-5.76MH //if (TX_Lo- RX_Lo) +IF =>5.76 ,then cal_pm.0=0
		movlw	D'3'
		call	Dif_tab	; =5.76MHz 
		movwf	y3

		movlw	D'2'
		call	Dif_tab		;=5.76MHz 
		movwf	y2

		movlw	D'1'
		call	Dif_tab	
		movwf	y1
		
		movlw	D'0'
		call	Dif_tab	
		movwf	y0

		movf	vfo3,0
		movwf	x3
		movf	vfo2,0
		movwf	x2
		movf	vfo1,0
		movwf	x1
		movf	vfo0,0
		movwf	x0
  		call  	sub_xy	;;(32bit)(32bit)|y(32bit)
		goto	DCm3


DevCalp ; x= 5.76MHz -o(TX_Lo- RX_Lo) +IF@p//;if (TX_Lo- RX_Lo) +IF <5.76 ,then cal_pm.0=1
		movlw	D'3'
		call	Dif_tab	; =5.76MHz 
		movwf	x3

		movlw	D'2'
		call	Dif_tab		;=5.76MHz 
		movwf	x2

		movlw	D'1'
		call	Dif_tab	
		movwf	x1
		
		movlw	D'0'
		call	Dif_tab	
		movwf	x0	

		movf	vfo3,0
		movwf	y3
		movf	vfo2,0
		movwf	y2
		movf	vfo1,0
		movwf	y1
		movf	vfo0,0
		movwf	y0
  		call  	sub_xy	;;(32bit)(32bit)|y(32bit)
		goto 	DCm3
	;----------
DCm3	movf	x3,0
		btfss	STATUS,Z
		goto	DCm35
		
		movf	x2,0
		btfss	STATUS,Z
		goto	DCm35

		movlw	B'10000000'	;if x1_x0> 7FFF ,then DCm35
		andwf	x1,0
		btfss	STATUS,Z
		goto	DCm35
		goto	DCm4

DCm35 	clrf	x3		;x=H'0F FF'=4095
		clrf	x2
		movlw	H'0F'
		movwf	x1
		movlw	H'FF'
		movwf	x0
		goto	DCm4

		;32,768Hz_VXO/5V 2^12=4096 (MCP4922)
		;32,768Hz/16  =4096/2 
DCm4	bcf		STATUS,C	;x= x *1/2
		rrf		x1,1
		rrf		x0,1

		bcf		STATUS,C	;x= x *1/4
		rrf		x1,1
		rrf		x0,1

		bcf		STATUS,C	;x= x *1/8
		rrf		x1,1
		rrf		x0,1

		bcf		STATUS,C	;x= x *1/16
		rrf		x1,1
		rrf		x0,1

		movf	x1,0
		btfss	STATUS,Z
		goto	DCm5	

		movlw	D'16'	;if x1_x0 < H'000F' *8=128Hz ,then Calibratio Lock
		subwf	x0,0		;W=x0 +(256-130)
		btfsc	STATUS,C	;if x0 >130 , then goto  DCm5
		goto	DCm5	
		goto	DCm7
	
DCm5	bcf		cal_in,0	;if Calibration<128Hz, then cal_in.0=1, else cal_in.0=0	
		btfss	CalSW   ;PORTA,5		;calibration SW
		goto	DCm50
		return

DCm7	bsf		cal_in,0	;if Calibration<128Hz, then cal_in.0=1, else cal_in.0=0	
		return

DCm50	;32,768Hz_VXO/5V 2^12=4096 (MCP4922)
		;32,768Hz/8  =4096 
		btfsc	cal_pm,0	;if (TX_VXO- RX_VXO) +IF <5.76 ,then cal_pm.0=1 
		call	add_vx				; ;VXO_V0=VXO_V0 +x	;TX VXO 12.76MHz Control Volt
		btfss	cal_pm,0	;if (TX_VXO- RX_VXO) +IF >5.76 ,then cal_pm.0=0 
		call	sub_vx				;VXO_V0=VXO_V0 -x	
		return

;----------------------
		;AFVol	;0 <AFVol< 17 //VR(0-1)= (256- AFVol x 4) x 16
AF_inc	incf	AFVol,1
		movlw	D'21'
		subwf	AFVol,0
		movlw	D'20'
		btfss	STATUS,Z ; if AFVol=D'21', then AFVol=D'20'
		movf	AFVol,0
		movwf	AFVol	
		goto	AF_conv

AF_dec	decf	AFVol,1
		movlw	D'255'
		subwf	AFVol,0
		movlw	D'0'
		btfss	STATUS,Z ; if AFVol=D'255', then AFVol=D'0'
		movf	AFVol,0
		movwf	AFVol	
		goto	AF_conv
	;------------
AF_conv bsf		VCF,0	; if AF VR Change,VCF.0=1, else 0
		movf	AFVol,0
		movwf	VR0
		bcf		STATUS,C
		rlf		VR0,1	; VR0=VR0 x 2
		bcf		STATUS,C
		rlf		VR0,1	; VR0=VR0 x 4

		comf	VR0,1  	;VR0= 255 -VR0		

		clrf	VR1
		bcf		STATUS,C	;VR(0-1)= VR x 2
		rlf		VR0,1
		rlf		VR1,1	
		bcf		STATUS,C	;VR(0-1)= VR x 4
		rlf		VR0,1
		rlf		VR1,1	
		bcf		STATUS,C	;VR(0-1)= VR x 8
		rlf		VR0,1
		rlf		VR1,1	
		bcf		STATUS,C	;VR(0-1)= VR x 16
		rlf		VR0,1
		rlf		VR1,1		

Voldp	movf	AFVol,0
		movwf	val0
		call	AFdc	;dp5-7 	10i

		movlw	H'56'	;uVv 
		movwf	dp1
		movlw	H'6F'	;uov 
		movwf	dp2
		movlw	H'6c'	;ulv 
		movwf	dp3

		movlw	H'20'   ;u_v
		movwf	dp4
		movwf	dp7
		movwf	dp8		
		return
;-------------------------------------
DAC_A	movf	mcp1,0	;MCP4922 Vout A
		andlw	B'00001111'
		iorlw	B'00110000'
		movwf	mcp1
		goto	mcp4922

DAC_B	movf	mcp1,0	;MCP4922 Vout B
		andlw	B'00001111'
		iorlw	B'10110000'
		movwf	mcp1
		goto	mcp4922

mcp4922	call	writb
		bsf		LDAC
		bcf		M_CS
		movlw	D'16'
		movwf	cn
		
mp10	bcf		SCK
		bcf		STATUS,C
		rlf		mcp0,1
		rlf		mcp1,1
		btfss	STATUS,C
		bcf		SDI
		btfsc	STATUS,C
		bsf		SDI		
		
		bsf		SCK
		decfsz	cn,1
		goto	mp10

mp20	bcf		SCK
		bsf		M_CS		
		bcf		LDAC
		bsf		LDAC
		return
		
;;---------------------------------------------------------------
VFOcalc		;Ngate=5			;x[32bit]=vfo[32bit] * N[8bit]
		movf	Ngate,0		;Gate time =0.2sec then multi by 5
		movwf	N
		call	mult_vN		;;x[32bit]=vfo[32bit] * N[8bit];VFON{Bx[3]-x[0]ɒ{VFOĂ.
		movf	x3,0		;
		movwf	vfo3

		movf	x2,0
		movwf	vfo2

		movf	x1,0
		movwf	vfo1

		movf	x0,0
		movwf	vfo0
		return
		;----------------

DSP_cal
uphet		;			;disp=Lo-IF
		movf	if3,0		;y=IF
		movwf	y3
	
		movf	if2,0	
		movwf	y2	
	
		movf	if1,0
		movwf	y1

		movf	if0,0
		movwf	y0

		movf	vfo3,0		;x=Lo= vfo
		movwf	x3
	
		movf	vfo2,0
		movwf	x2
		
		movf	vfo1,0
		movwf	x1

		movf	vfo0,0
		movwf	x0

  		call  	sub_xy	;;(32bit)(32bit)|y(32bit)@
		goto	calc1
calc1		
		movf	x3,0
		movwf	val3

		movf	x2,0
		movwf	val2

		movf	x1,0
		movwf	val1

		movf	x0,0 
		movwf	val0 

		call	dcmain			;16i-10iϊ
		return
;---------------------------------
Mix_cal	movf	vfo3,0		;
		movwf	val3

		movf	vfo2,0
		movwf	val2

		movf	vfo1,0
		movwf	val1

		movf	vfo0,0
		movwf	val0

		call	dcmain			;16i-10iϊ

		movf	dec2,0	;dec2; 10MHz
		movwf	dp1
		movf	dec3,0	;dec3; 1MHz
		movwf	dp2
		movlw	H'4d'	;uMv	 ;4dh
		movwf	dp3

		movf	dec4,0	;dec4; 100kHz
		movwf	dp4
		movf	dec5,0	;dec5; 10kHz
		movwf	dp5
		movf	dec6,0	;dec6; 1kHz
		movwf	dp6
		movlw	H'2e'	;u.v;2eh
		movwf	dp7

		movf	dec7,0	;dec7; 0.1kHz
		movwf	dp8	
		return

;========S meter===== 
	;S meter	;A/DϊJn@@AN0|[g@AiO	
adloop	bcf		RS
		movlw	B'01000001'	;set AD_channel=AN0, conversion_clock=16Tosc, )  
		movwf	ADCON0

		bsf		STATUS,5	;oN1
		movlw	B'11001110'	;pinset(AN4=D,AN3=D,AN2=D,AN1=D,AN0=Analog, Vref+=5V, Vref-=GND) 
		movwf	ADCON1	;Right Justified 
		bcf		STATUS,5	;oN0

		movlw	D'25'		;acquisition time wait 25usec
		movwf 	wait_cn	
		call	wait_us 

		bsf  	ADCON0,GO
ad_pol		
		nop  
		btfsc	ADCON0,GO
		goto	ad_pol		;AD conv polling

		bsf  	STATUS,RP0	;oN1
		movf	ADRESL,0	;ADϊʂ@VsɎ荞݁@L8biti0-255j
		bcf  	STATUS,RP0	;oN0
		movwf	Vs

		movf	ADRESH,0  	;if ADRESH not=0, Vs=255
		movlw	D'255'
		btfsc	STATUS,Z
		movf	Vs,0
		movwf	Vs

		bcf  	ADCON0,0	;AD OFF
		bcf  	ADCON0,GO	;AD conv reset
		return
	;-----------
LCD_sm	movlw	D'8'
		movwf	cn
		clrf	poi
Lsm1	movf	poi,0
		call	S_tabl
		subwf	Vs,0	;W=Vs+ (256-S_t)
		btfsc	STATUS,C ;if Vs> S_t, C=1 then goto out
		goto	Lsm_out
		btfsc	STATUS,Z ;if Vs= S_t, C=1 then goto out
		goto	Lsm_out
		nop
		incf	poi,1
		decfsz	cn,1
		goto	Lsm1

Lsm_out	incf	poi,0	;W=poi +1
		movwf	ct
		sublw	D'8'		;W=8 +(256-ct)	;Max. ct<=8
		movlw 	D'8'	
		btfsc	STATUS,C	;Max. ct<=8
		movf	ct,0
		movwf	ct

LCD1	movlw	D'8'
		movwf	cn	
		movlw	dp1		;LCD 1sP
		movwf	FSR
		movf	ct,1	;if ct=0, then skip "LCD2"
		btfsc	STATUS,Z
		goto	LCD3

LCD2	movlw	H'FF'		;[]
		movwf	INDF
		incf 	FSR,1
		decf	cn,1
		decfsz	ct,1
		goto	LCD2

LCD3	movf	cn,1
		btfsc	STATUS,Z	;if cn=0, then return 
		goto	LCD_e
LCD5	movlw	H'2d'	;[-]
		movwf	INDF
		incf 	FSR,1			
		decfsz	cn,1
		goto	LCD5
LCD_e	return	
;================= S meter END==================
;===============================================
;--------------------
put1st		; 590step+680us
		call	writb				;/8step
		clrf	poi	;tab_dp(LCD)1Ԗڕ\
		movlw	H'80'
		movwf	d4
		bcf		RS		;cursorʒu 
		call	write_lcd4			;/20step+40us
		movlw	D'8'			;mov	cn,#8	;8
		movwf	cn
		goto	dp_bun

put2nd		; 580step+680us
		call	writb				;/8step
		movlw	D'8'	;tab_dp(LCD)8Ԗ=LCD2s1\
		movwf	poi
		movlw	H'c0'	;cursol 2s
		movwf	d4
		bcf		RS		;cursorʒu 
		call	write_lcd4			;/20step+40us
		movlw	D'8'			;mov	cn,#8	;8
		movwf	cn
		goto	dp_bun

;-------;\郋[`	;\X^ĆAtab_dpɑΉ	;poi=ʒuA0<=poi<tab_dpmaxl
dp_bun		;\				;/16x(35step+40us)=560step+640us
		bsf		RS
dpb1	movf	poi,0
		call	tab_dp
		movwf	d4
		btfsc	d4,7		;if d4.7=1, then dpb4
		goto	dpb4
		;goto	dpb3
dpb3	movwf	FSR		;WX^[AhX
		movf	INDF,0
		movwf	d4
		goto	dpb5			

dpb4	bcf		d4,7		;d4ɑΉ镶
dpb5	call	write_lcd4	;
		incf	poi,1
		decfsz	cn,1
		goto	dpb1
		return
;--------------------------------------------------
readb	bsf		STATUS,RP0	;oN1	;rb.2-7s input mode
		movlw	B'11111101'	;rb.0-7sin  !rb,#11111111b
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		return

;---------
writb	bsf		STATUS,RP0	;oN1
		movlw	B'00000001'	;rb0,ȊOsout  	
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		return
;----------------
;----------------
;		t[`
init_lcd
		bcf		RS			; RS='L'	
		movlw	B'00110000'	;mov	d8,#00110000b
		movwf	d8
		call	write_lcd8
		call	wait_20			; wait 4.1msȏ

		movlw	B'00110000'	;mov	d8,#00110000b
		movwf	d8
		call	write_lcd8
		call	wait_20			; wait 100usȏ

		movlw	B'00100000'		;mov	d8,#00100000b
		movwf	d8
		call	write_lcd8		; 0 0 0010 (4bit)
		
		movlw	B'00101000'	;mov	d4,#00101000b	; duty,font set9:Function set
		movwf	d4		
		call	write_lcd4

		movlw	B'00001000'		;mov	d4,#00001000b		; display off
		movwf	d4
		call	write_lcd4		

		movlw	B'00000001'		;mov	d4,#00000001b	; NAR}h:Clear Display
		movwf	d4
		call	write_lcd4
		call	wait_20		; NAI܂ő҂ Q0mbȏ
		
		movlw	B'00000110'		;mov	d4,#00000110b		; entry mode set
		movwf	d4
		call	write_lcd4

		movlw	B'00001110'	;mov	d4,#00001110b		; display on,cursor on
		movwf	d4
		call	write_lcd4
		return
;		Srbg[hptCg[`
write_lcd4
		movf	d4,0	;mov	d8,d4
		movwf	d8
		call	write_lcd8		;4ޯ
		
		movf	d4,0		;mov	d8,d4
		movwf	d8
		swapf	d8,1
		call	write_lcd8		;ʂSޯ
		return
;
;		Wrbg[hptCg[`
init_1	movlw	B'00110000'	;mov	d8,#00110000b
		movwf	d8
;
write_lcd8	
		clrf	cs
		rlf		d8,1		;;d8.7cs.0
		rrf		cs,1
		rlf		d8,1		;d8.6cs.1
		rrf		cs,1
		rlf		d8,1		;;d8.5cs.2
		rrf		cs,1		
		rlf		d8,1		 ;d8.4cs.3W
		rrf		cs,0


		andlw	B'11110000'
		btfsc	cal_in,0	;if Calibration<130Hz, then cal_in.0=1, else cal_in.0=0	
		xorlw	B'00000010'	;	PORTB,1		;calibration  Lock LED

		movwf	PORTB		; Wqa|[g֏o
		bsf		E			; ds'H'
		nop
		bcf		E

		movlw	D'40'	;wait 40sec
		movwf	wait_cn
		call	wait_us
		return

;;;;****************

;  ---------------------------------------------------------------
;		I[_[̃EFCg
;
wait_255
		movlw	D'255'	;mov	wait_cn,#255
		movwf	wait_cn
		goto	wait_ms

wt15ms	movlw	D'15'	;mov	wait_cn,#15
		movwf	wait_cn
		goto	wait_ms

wt4ms	movlw	D'4'	;mov	wait_cn,#4
		movwf	wait_cn
		goto	wait_ms

wt1ms	movlw	D'1'	;mov	wait_cn,#4
		movwf	wait_cn
		goto	wait_ms

wt255u	movlw	D'255'	;mov	wait_cn,#255
		movwf	wait_cn
		goto	wait_us

wt5u	movlw	D'5'	;mov	wait_cn,#5
		movwf	wait_cn
		goto	wait_us

wait_20	movlw	D'20'		;mov	wait_cn,#20
		movwf	wait_cn
		goto	wait_ms		
;
;		ʂI[_[̃EFCg
wait_us				;3 steps=1.2ʂ̃JEg
wait_us0	decfsz	wait_cn,1	;1cycle
		goto	wait_us0		;2cycle
		return

;
;		I[_[̃EFCg
;
wait_ms
wait_ms0
		movlw 	D'0'
		movwf	wait_cn2
wait_ms1
		nop	
		nop
		nop
		nop
		nop	
		nop
		nop
		
		decfsz	wait_cn2,1
		goto	wait_ms1

		decfsz	wait_cn,1
		goto	wait_ms0		

		return

;---------------------------------------------------------	
;	Z		(32bit)(32bit)|y(32bit)@
;
sub_xy
		movf	y0,0				;sub	x[0],y[0]
		subwf	x0,1
		movlw	1
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1
		btfss	STATUS,C
		subwf	x3,1

		movf	y1,0				;sub	x[1],y[1];
		subwf	x1,1
		movlw	1
		btfss	STATUS,C
		subwf	x2,1
		btfss	STATUS,C
		subwf	x3,1

		movf	y2,0				;sub	x[2],y[2];
		subwf	x2,1		
								
		movlw	1
		btfss	STATUS,C
		subwf	x3,1
		
		movf	y3,0				;sub	x[3],y[3]
		subwf	x3,1								
		return
;--------------------------------------------------------------------
; 	Z	(32bit)(32bit){y(32bit)@
;
add_xy				
		movf	y0,0				;add	x[0],y[0]
		addwf	x0,1
		movlw	1
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y1,0				;add	x[1],y[1]
		addwf	x1,1
								
		movlw	1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1
		
		movf	y2,0				;add	x[2],y[2]	]
		addwf	x2,1
							
		movlw	1
		btfsc	STATUS,C
		addwf	x3,1

		movf	y3,0				;add	x[3],y[3]
		addwf	x3,1		
								
		return

;--------------------------------------------------------------------
; 	Z	vfo(32bit)vfo(32bit){if(32bit)@
;
add_vfo				
		movf	if0,0				;add	vfo[0],if[0]
		addwf	vfo0,1
		movlw	1
		btfsc	STATUS,C
		addwf	vfo1,1
		btfsc	STATUS,C
		addwf	vfo2,1
		btfsc	STATUS,C
		addwf	vfo3,1
		
		movf	if1,0				;add	vfo[1],if[1]
		addwf	vfo1,1
								
		movlw	1
		btfsc	STATUS,C
		addwf	vfo2,1
		btfsc	STATUS,C
		addwf	vfo3,1
		
		movf	if2,0				;add	vfo[2],if[2]	]
		addwf	vfo2,1
							
		movlw	1
		btfsc	STATUS,C
		addwf	vfo3,1

		movf	if3,0				;add	vfo[3],if[3]
		addwf	vfo3,1		
								
		return
;-----------------------------
; Z@				; ;VXO_V0(16bit)=VXO_V0(16bit) -x(16bit)
					;Min VXO_V0(16bit)=> 0 
sub_vx	movf	x0,0				;sub	VXO_V0,x[0]
		subwf	VXO_V0,1
		movlw	1
		btfss	STATUS,C
		subwf	VXO_V1,1

		movf	x1,0				;sub	VXO_V1,x[1]
		subwf	VXO_V1,1		;VXO_V1 = VXO_V1 +(256- x1)

		btfsc	STATUS,C
		return

		clrf	VXO_V0
		clrf	VXO_V1		
		return
;-----------------
; Z@				; ;VXO_V0(16bit)=VXO_V0(16bit) +x(16bit)
					; Max VXO_V0(16bit)<= H'0F FF'=4095
add_vx	movf	x0,0				;add	VXO_V0,x[0]
		addwf	VXO_V0,1
		movlw	1
		btfsc	STATUS,C
		addwf	VXO_V1,1
		
		movf	x1,0				;add	VXO_V1,x[1]
		addwf	VXO_V1,1	

		movlw	B'11110000'
		andwf	VXO_V1,00
		
		btfsc	STATUS,Z ;if VXO_V0(16bit)> H'0F FF'=4095, VXO_V0=4095
		return

		movlw	H'FF'	;VXO_V0=4095
		movwf	VXO_V0
		movlw	H'0F'
		movwf	VXO_V1			
		return

;---------------------------------------------------------------------
;	WrbgoCiPOiϊ@(AFVol)
;	valɂRQrbgf[^uBiva[0])
;
;	AFdcR[B
;
;	dpɓi[B
;		(dp5, dp6, dp7)
;		dp5ŏʌdp7ŉʌłB
AFdc
		movlw	dp7		; i[ꏊl
		movwf	FSR
		call	devide2			; ŉʕϊ 
		call	devide2			;3JԂ
		call	devide2
		return

;		POTu[`
;		POŏZ܂
;
devide2		
		movlw	D'8'		;; WrbgԂ
		movwf	cn
		clrf	val_m
devide3		
		bcf		STATUS,C
		rlf		val0,1
		rlf		val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m		;mov	val_m,w
		btfsc	STATUS,C
		incf	val0,1
		
		decfsz	cn,1		;djnz	cn,devide0
		goto	devide3

		decf	FSR,1
		movf	val_m,0		;mov	indirect,val_m		; ]
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	INDF
		return

	
;---------------------------------------------------------------------
;	RQrbgoCiPOiϊ
;
;	valɂRQrbgf[^uBival[3]:val[2]:val[1]:va[0])
;
;	dcmainR[B
;
;	decɓi[B
;		(dec[0]:dec[1]:...:dec[8]:dec[9])
;		dec[0]ŏʌdec[9]ŉʌłB
;
;	ϊval͔j󂳂B
;
;	sample:
;		val	= 00:00:04:D2 h
;		dec	= 00:00:00:00:00:00:01:02:03:04
;                  dec(0):dec(1):(2):(3):(4):(5):(6):(7):(8):dec(9)
;						(1,234)
;
	

dcmain
		movlw	dec9		;	;mov	fsr,#dec_top		; i[ꏊl
		movwf	FSR
		incf	FSR,1
		call	devide			; ŉʕϊ 
		call	devide			;10JԂ
		call	devide
		call	devide
		call	devide

		call	devide
		call	devide
		call	devide
		call	devide
		call	devide			; ŏʕϊ

zeroblank
		movlw	D'3'		;**.*MHz\̑2܂blank\
		movwf	cn			;Zero Blanku

		movlw	dec0		;movlw  dec0		;mov	fsr,#20h		; dec[0]i[ꏊl
		movwf	FSR
zb1		movlw	B'00110000'
		subwf	INDF,0
		btfss	STATUS,Z		;if dec[]=00, then continue, else return
		return
zb2			;if dec[]=00, then dec[]=20hł́Ablank \ƂȂ
		movlw	H'20'
		movwf	INDF	;movwf	indirect

		incf	FSR,1
		decfsz	cn,1
		goto	zb1
		return

;
;		POTu[`
;		POŏZ܂
;
devide		
		movlw	D'32'		;mov	cn,#32			; RQrbgԂ
		movwf	cn
		clrf	val_m
devide0		
		bcf		STATUS,C
		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val3,1
		rlf		val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m		;mov	val_m,w
		btfsc	STATUS,C
		incf	val0,1
		
		decfsz	cn,1		;djnz	cn,devide0
		goto	devide0

		decf	FSR,1
		movf	val_m,0		;mov	indirect,val_m		; ]
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	INDF
		return
;----------------------------------------end of 10iϊ
;-----------------------------------------------------------------------
;	|Z		x[32bit]=vfo[32bit] * N[8bit]
;
;	vfo32rbgf[^uB
;		ivfo[3]:vfo[2]:vfo[1]:vfo[0]) 	vZߒ val_m g
;       N 8ޯްuB
;                 N ;  ő  #255łB
;
;	xɓi[B
;                ix[3]:x[2]:x[1]:x[0]) 
;       		
;	ϊ N ͔j󂳂ȂB
;
;
mult_vN	clrf		x3
		clrf		x2
		clrf		x1
		clrf		x0
		clrf		val_m			;ǉ1
			
		movlw 	D'8'
		movwf 	cn
mult0		
		btfss	N,0
		goto	mutpas

		movf	vfo0,0				;add	x[0],vfo[0]
		addwf	x0,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1

		movf	vfo1,0				;add	x[1],vfo[1]
		addwf	x1,1		
									
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1

		movf	vfo2,0				;add	x[2],vfo[2]	
		addwf	x2,1		
									
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x3,1

		movf	vfo3,0				;add	x[3],vfo[3]	
		addwf	x3,1			
		
mutpas	bcf		STATUS,C
		rlf		vfo0,1
		rlf		vfo1,1
		rlf		vfo2,1
		rlf		vfo3,1
		rlf		val_m,1		;ǉ1
		btfsc	STATUS,C
		bsf		vfo0,0

		bcf		STATUS,C
		rrf		N,1
		btfsc	STATUS,C
		bsf		N,7

		decfsz	cn,1			;	djnz	cn,mult0
		goto	mult0

		movlw	D'8'
		movwf	cn
multrot	bcf		STATUS,C
		rrf		val_m,1				;ǉ1
		rrf		vfo3,1
		rrf		vfo2,1
		rrf		vfo1,1
		rrf		vfo0,1
	;	btfsc	STATUS,C
	;	bsf		vfo3,7
		decfsz	cn,1			;djnz	cn,multrot
		goto 	multrot
		return
;---------------------------end of |Z
;-----------------------------------------------------
;	32rbgoCiZTu[`
;		val<32bit> = x<32bit> / y<16bit>; 
;
;	x 32 rbgf[^u܂B
;		ix[3]:x[2]:x[1]:x[0]) 
;       y 16ޯްu܂B
;              y[1]:y[0];  ő  H'FFFF'łB
;
;	val ɓi[܂B
;                ival[3]:val[2]:val[1]:val[0])  ]x[1][0]
;	vZ̉ߒ	Z		(32bit)(32bit)|y(32bit)gp
;       vZ̉ߒval[3]-val[0]Aval[0] ĝŒ`KvłB
;		
;
Div_xYY
		movf	y1,0		;y=y *256*256
		movwf	y3
		movf	y0,0
		movwf	y2
		clrf	y1
		clrf	y0
		movlw	D'17'			
		movwf	cn
		movlw	D'16'			
		movwf	cs
		clrf	val0
		clrf	val1
		clrf	val2
		clrf	val3

Dv1		movf	cs,1
		btfsc	STATUS,Z	;if y=0, can't divided then return
		return	
		btfsc	y3,7	;if y3.7 =0, then y rotate
		goto	Dv2
		bcf		STATUS,C
		rlf		y2,1
		rlf		y3,1
		incf	cn,1
		decfsz	cs,1
		goto 	Dv1		
				
Dv2		;;x>=y ? check
		movf	x3,0
		subwf	y3,0		; W=y3+ (256-x3)
		btfss	STATUS,C	; if y3<x3, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y3>x3, then Dv4
		goto	Dv4

		movf	x2,0
		subwf	y2,0		; W=y2+ (256-x2)
		btfss	STATUS,C	; if y2<x2, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y2>x2, then Dv4
		goto	Dv4

		movf	x1,0
		subwf	y1,0		; W=y1+ (256-x1)
		btfss	STATUS,C	; if y1<x1, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y1>x1, then Dv4
		goto	Dv4

		movf	x0,0
		subwf	y0,0		; W=y0+ (256-x0)
		btfss	STATUS,C	; if y0<x0, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y0>x0, then Dv4
		goto	Dv4
		goto	Dv3

Dv3		;x>=y@Ȃ̂ňZ
		call 	sub_xy	;(32bit)(32bit)|y(32bit)
		bsf		STATUS,C	
		goto	Dv5

Dv4		;x<y Ȃ̂ 
		bcf		STATUS,C	
Dv5		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val3,1	
		decfsz	cn,1		
		goto	Dv6
		return
Dv6		bcf		STATUS,C
		rrf		y3,1	
		rrf		y2,1
		rrf		y1,1	
		rrf		y0,1
		goto	Dv2

;;;;;;;;;;;;======================
;;;;****************
;    ---------------------------------------------------
;	;------------------------
;		;#00h   #01h    #02h    #03h	#04h	
;		;HisROM,AFVol,  VXO_V0, VXO_V1,     4Aaddress	
load_m	movlw	H'0'
		movwf	ADDR
		movlw	D'4'      
		movwf	scn

		movlw	H'60'	;HisROM   ;;HisROM, AFVol, VXO_V0, VXO_V1,  4Aaddress  
		movwf	FSR
load_rt	bcf		STATUS,RP0	;Bank2/Select Bank of EEADR
		bsf		STATUS,RP1	;Bank2/
		
		movf	ADDR,0      	;EEPROM address 0&h
		movwf	EEADR		; Data Memory Address to read

		bsf		STATUS,RP0		;Bank3/	Select Bank of EECON1
		bcf		EECON1,EEPGD	; Select Bank of EECON1
		bsf		EECON1,RD		; EE Read

		bcf		STATUS,RP0		;Bank2/ Select Bank of EEDATA
		movf	EEDATA,0      
		movwf	INDF

		incf	ADDR,1
		incf	FSR,1
		decfsz	scn,1
		goto	load_rt

		bcf		STATUS,RP0	;Bank0
		bcf		STATUS,RP1
		return
;    ------------------------------------
Memo	movlw	H'0'
		movwf	ADDR
		movlw	D'4'      
		movwf	scn

		movlw	H'60'		;HisROM ;HisROM, AFVol, VXO_V0, VXO_V1,  4Aaddress 
		movwf	FSR
sav_i5	movf	INDF,W
		movwf	VALUE
		call	datawrite
		incf	ADDR,1
		incf	FSR,1
		decfsz	scn,1
		goto	sav_i5
		return
;   ----------------------------------------		
datawrite	
		bsf		STATUS,RP0	;Bank3
		bsf		STATUS,RP1	;Bank3/	Select Bank of EECON1

	;	bcf		EECON1,WR
dr1		btfsc	EECON1,WR	;Wait for write to complete
		goto	dr1

		bcf		STATUS,RP0	;Bank2/Select Bank of EEADR
		movf	ADDR,W
		movwf	EEADR		;Data Memory Address to write

		movf 	VALUE,W  	;
		movwf	EEDATA 		; Data Memory Value to write

		bsf		STATUS,RP0	;Bank3/	Select Bank of EECON1
		bcf		EECON1,EEPGD	;; Point to DATAmemory 	
		bsf		EECON1,WREN		;WRENޯ on; Enable writes

		bcf		INTCON,GIE 		; Disable INTs
	;-----
		movlw	H'55'
		movwf	EECON2
		movlw	H'aa'
		movwf	EECON2
		bsf		EECON1,WR 		; Set WR bit to begin write
	;-----
		bsf		INTCON,GIE 		; Enable INTs.
		bcf		EECON1,WREN 	; Disable writes

		call	wt15ms		; wait 15ms
		bcf		STATUS,RP0	;Bank0
		bcf		STATUS,RP1
		return
;------------------------------	
; initialize eeprom locations

	ORG	0x2100
	DE	0x00, 0x01, 0x02, 0x03


	END                       ; directive 'end of program'
